/*
 * OpenMobileIS - a free Java(TM) Framework for mobile applications Java(TM)
 * Copyright (C) 2004-2006 Philippe Delrieu
 * All rights reserved.
 * Contact: pdelrieu@openmobileis.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *  Author : Philippe Delrieu
 *
 *  Modifications :
 *  Creation P.Delrieu
 *
 */
package org.openmobileis.bundle.coldupdate.terminal;

import java.io.File;

/**
 * @author phil
 *
 */
public final class ColdUpdateStarter {

	/**
	 *
	 */
	public ColdUpdateStarter() {
	}

	private void copyJarFiles(String modulelibpath, String libPath)	{
		File moduleLib = new File(modulelibpath);
		String[] jarList = moduleLib.list();
		File newFile = null;
		for (int i=0; i<jarList.length; i++)	{
			newFile = new File(modulelibpath+File.separator+jarList[i]);
			newFile.renameTo(new File(libPath+File.separator+jarList[i]));
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try	{
			ColdUpdateStarter starter = new ColdUpdateStarter();
//			Properties props = new Properties();
//			props.load(new FileInputStream(System.getProperty("user.dir"+File.separator+"coldupdateprops.properties")));
			String modulelibpath = System.getProperty("user.dir")+"/WEB-INF/module/jar";
			String libPath = System.getProperty("user.dir")+"/WEB-INF/lib";
			starter.copyJarFiles(modulelibpath, libPath);
//			String startcmd = props.getProperty("org.openmobileis.bundle.coldupdate.terminal.execcmd");
		//	starter.startJavaProcess(startcmd);
		} catch (Throwable ex)	{
			ex.printStackTrace();
		}
	}

}
