package org.openmobileis.bundle.osgi.services;

import org.openmobileis.common.intl.IntlResourceManager;
import org.openmobileis.embedded.webserver.templates.Freemarkerv1JarTemplateCache;
import org.openmobileis.embedded.webserver.templates.TemplateRetrieverService;

import freemarker.template.FileTemplateCache;
import freemarker.template.Template;

public final class TemplateRetrieverServiceImpl implements TemplateRetrieverService {
	private String moduleName;
  private FileTemplateCache templateCache = null;

  public TemplateRetrieverServiceImpl(String name, String rootTemplatePath)	{
		moduleName = name;
    templateCache = new Freemarkerv1JarTemplateCache(rootTemplatePath);
    templateCache.setFilenameSuffix("htm");
	}
	public String getModuleName() {
		return moduleName;
	}

	public Template getServiceTemplate(String relatifPath) {
    IntlResourceManager resourceManager = IntlResourceManager.getManager();
    String newrelatifPath = resourceManager.getLocalizedFileName(relatifPath, false);
    try	{
    	newrelatifPath = relatifPath.replace('\\', '/');
    	return (Template)templateCache.getItem(newrelatifPath);
    } catch (Throwable ex)	{
  		newrelatifPath = relatifPath;
    	newrelatifPath = newrelatifPath.replace('\\', '/');
    	return (Template)templateCache.getItem(newrelatifPath);
    }
	}
	
  public boolean isTemplateExist(String relatifPath)	{
  	return this.getServiceTemplate(relatifPath) != null;
  }
	
}
