/*
 * OpenMobileIS - a free Java(TM) Framework for mobile applications Java(TM)
 * Copyright (C) 2004-2008 Philippe Delrieu
 * All rights reserved.
 * Contact: openmobileis@e-care.fr
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *  Author : Philippe Delrieu
 * 
 */
package org.openmobileis.bundle.update.server;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Iterator;
import java.util.jar.Attributes;
import java.util.jar.JarFile;

import org.openmobileis.bundle.update.terminal.ApplicationUpdateJarUtil;
import org.openmobileis.common.util.log.LogManager;
import org.openmobileis.synchro.openmsp.OpenMSPException;
import org.openmobileis.synchro.openmsp.protocol.Command;
import org.openmobileis.synchro.openmsp.protocol.ContainerMessage;
import org.openmobileis.synchro.openmsp.protocol.DataItem;
import org.openmobileis.synchro.openmsp.protocol.Element;
import org.openmobileis.synchro.openmsp.protocol.Result;
import org.openmobileis.synchro.openmsp.protocol.Status;
import org.openmobileis.synchro.openmsp.server.synctarget.DefaultOpenMSPSynchroTargetListener;
import org.openmobileis.synchro.openmsp.server.util.MemoryFile;
import org.openmobileis.synchro.security.auth.Credential;
import org.xmlpull.v1.XmlPullParserException;

/**
 * Title:        OpenMobileIS project source <BR>
 * Description: 
 * @author	Philippe Delrieu
 * @since	JDK 1.1
 * @version 1.0.
 */
public final class FullAppUpdateSynchroTarget extends DefaultOpenMSPSynchroTargetListener {
  
  protected File currentjarFile;
  //protected File xmlFile;
  protected byte[] terminaljar;
  
  public FullAppUpdateSynchroTarget(File jarfile) throws FileNotFoundException, XmlPullParserException, IOException {
  	this.currentjarFile = jarfile;
  }
  
  /* (non-Javadoc)
   * @see org.openmobileis.synchro.openmsp.server.synctarget.DefaultOpenMSPSynchroTargetListener#getTargetName()
   */
  public String getTargetName() {
    return ApplicationUpdateJarUtil.FULL_APP_UPDATE_NAME;
  }

  /* (non-Javadoc)
   * @see org.openmobileis.synchro.openmsp.server.synctarget.DefaultOpenMSPSynchroTargetListener#processMapCommand(org.openmobileis.synchro.security.auth.Credential, org.openmobileis.synchro.openmsp.protocol.ContainerMessage)
   */
  protected ContainerMessage processMapCommand(Credential cred, ContainerMessage mapContainer) {
    return null;
  }

  /* (non-Javadoc)
   * @see org.openmobileis.synchro.openmsp.server.synctarget.DefaultOpenMSPSynchroTargetListener#notifySyncAction(long, org.openmobileis.synchro.security.auth.Credential, org.openmobileis.synchro.openmsp.protocol.Command)
   */
  protected void notifySyncAction(long sessionId, Credential cred, Command syncCommand) throws OpenMSPException {
  }

  /* (non-Javadoc)
   * @see org.openmobileis.synchro.openmsp.server.synctarget.DefaultOpenMSPSynchroTargetListener#processResultCommand(org.openmobileis.synchro.security.auth.Credential, org.openmobileis.synchro.openmsp.protocol.Result)
   */
  protected void processResultCommand(Credential cred, Result resultCommande) throws OpenMSPException {
  }

  /* (non-Javadoc)
   * @see org.openmobileis.synchro.openmsp.server.synctarget.DefaultOpenMSPSynchroTargetListener#processStatusCommand(org.openmobileis.synchro.security.auth.Credential, org.openmobileis.synchro.openmsp.protocol.Status)
   */
  protected void processStatusCommand(Credential cred, Status statusCommande) throws OpenMSPException {
  }

  /* (non-Javadoc)
   * @see org.openmobileis.synchro.openmsp.server.synctarget.DefaultOpenMSPSynchroTargetListener#processAddCommand(org.openmobileis.synchro.security.auth.Credential, org.openmobileis.synchro.openmsp.protocol.ContainerMessage)
   */
  protected Status processAddCommand(Credential cred, ContainerMessage addContainer) throws OpenMSPException {
    return null;
  }

  /* (non-Javadoc)
   * @see org.openmobileis.synchro.openmsp.server.synctarget.DefaultOpenMSPSynchroTargetListener#processDeleteCommand(org.openmobileis.synchro.security.auth.Credential, org.openmobileis.synchro.openmsp.protocol.ContainerMessage)
   */
  protected Status processDeleteCommand(Credential cred, ContainerMessage deleteContainer) throws OpenMSPException {
    return null;
  }

  /* (non-Javadoc)
   * @see org.openmobileis.synchro.openmsp.server.synctarget.DefaultOpenMSPSynchroTargetListener#processReplaceCommand(org.openmobileis.synchro.security.auth.Credential, org.openmobileis.synchro.openmsp.protocol.ContainerMessage)
   */
  protected Status processReplaceCommand(Credential cred, ContainerMessage replaceContainer) throws OpenMSPException {
      return null;
  }

  /* (non-Javadoc)
   * @see org.openmobileis.synchro.openmsp.server.synctarget.DefaultOpenMSPSynchroTargetListener#beginProcessOpenMSpCommand(org.openmobileis.synchro.security.auth.Credential)
   */
  protected void beginProcessOpenMSpCommand(Credential cred) throws OpenMSPException {
  }

  /* (non-Javadoc)
   * @see org.openmobileis.synchro.openmsp.server.synctarget.DefaultOpenMSPSynchroTargetListener#endProcessOpenMSpCommand()
   */
  protected ContainerMessage[] endProcessOpenMSpCommand() throws OpenMSPException {
    return null;
  }

  /* (non-Javadoc)
   * @see org.openmobileis.synchro.openmsp.server.synctarget.DefaultOpenMSPSynchroTargetListener#processGetCommand(org.openmobileis.synchro.security.auth.Credential, org.openmobileis.synchro.openmsp.protocol.ContainerMessage)
   */
  protected ContainerMessage[] processGetCommand(Credential cred, ContainerMessage getContainer) throws OpenMSPException {
     //construct return command
  	Command getCommand = (Command)getContainer.getElement();
    DataItem item = (DataItem) getContainer.nextMessage().getElement();
    try {   
	    String pdaversion = item.getData();
	    if (pdaversion == null) pdaversion="";
	    String serverversion = this.readJarVersion(this.currentjarFile);
	    Result resultCommand = new Result(getCommand.getCmdId(), this.getTargetName(), this.getTargetName());
	    ContainerMessage resultContainer = new ContainerMessage(resultCommand);
	    LogManager.traceDebug(0, "FullAppUpdateSynchroTarget processGetCommand pdaversion :"+pdaversion);
	    LogManager.traceDebug(0, "FullAppUpdateSynchroTarget processGetCommand serverversion :"+serverversion);
      if (!pdaversion.equals(serverversion))    { //manage file modification.
  	    LogManager.traceDebug(0, "FullAppUpdateSynchroTarget processGetCommand UPDATE PDA");
      	MemoryFile mf = new MemoryFile(this.currentjarFile);
      	mf.setFileName(ApplicationUpdateJarUtil.APPLICATION_JAR_FILENAME);
        this.addFileToSynchro(mf);
        DataItem newItem = new DataItem(Element.ITEM, "jarfile", ApplicationUpdateJarUtil.APPLICATION_JAR_FILENAME, null, null);
        resultContainer.add(newItem);
      } else  {
        DataItem newItem = new DataItem(Element.ITEM, "nofile", "nofile", null, null);
        resultContainer.add(newItem);
      }
      ContainerMessage[] ret = new ContainerMessage[1];
      ret[0] = resultContainer;
      return ret;
   } catch (Exception ex)  {
    	LogManager.traceError(0, ex);
      Status status = new Status(getCommand.getCmdId(), Status.STATUS_FAILED);
      status.setCmdRef(getCommand.getCmdId());
      ContainerMessage statusContainer = new ContainerMessage(status);
      ContainerMessage[] ret = new ContainerMessage[1];
      ret[0] = statusContainer;
      return ret;
    }
  }
  
  private String readJarVersion(File file)	throws IOException{
  	String version = "";
		if (file.exists()) {
			JarFile jarFile = new JarFile(file);
			try {
				if (jarFile.getManifest() != null) {
					Iterator iter = jarFile.getManifest().getMainAttributes().keySet().iterator();
					while (iter.hasNext()) {
						Attributes.Name attribute = (Attributes.Name) iter.next();
						if (attribute.equals(ApplicationUpdateJarUtil.VERSIONNAME)) {
							version = jarFile.getManifest().getMainAttributes().getValue(attribute);
						}
					}
				}
			} finally {
				if (jarFile != null) {
					try {
						jarFile.close();
					} catch (IOException ioe) {
					}
				}
			}
		}
		return version;
  }

}
