/*
 * OpenMobileIS - a free Java(TM) Framework for mobile applications Java(TM)
 * Copyright (C) 2004-2009 Philippe Delrieu
 * All rights reserved.
 * Contact: pdelrieu@openmobileis.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *  Author : Philippe Delrieu
 * 
 */

package org.openmobileis.bundle.update.terminal;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.openmobileis.common.util.log.LogManager;
import org.openmobileis.services.Service;
import org.openmobileis.services.common.ServiceManager;

/**
 * @author pdelrieu
 *
 */
public final class ApplicationUpdateStatusService extends Service {
	//int counter  = 0;
	/**
	 * return the string true if the application update is still in process. false otherwise
	 */
	public ApplicationUpdateStatusService() {
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.services.Service#getServiceUri()
	 */
	public String getServiceUri() {
		return ServiceManager.getManager().getServiceBaseURI() + "/updatesynchrostatus";
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.services.Service#run(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	public void run(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
		String ret = "<ret>false</ret>";
		if (!ApplicationUpdateJarUtil.updateStarted) ret = "<ret>true</ret>";
	//	if (counter++==10)ret = "<ret>true</ret>";
		res.getWriter().write(ret);
		res.setStatus(200);
		res.setContentLength(ret.length());
		LogManager.traceDebug(0, "ApplicationUpdateStatusService Called.");
	}
	
	/* 
	 * 
	 * Exemple of script to update HTML page when update is over. Doesn't work on Wince and windows mobile 5.0
	 *
	<if updateappli>
	<script type="text/javascript" src="/openmisajax.js"></script>
	<script language="JavaScript">

	var t;
	function makerequest()
	{
		try	{
			OPENMISSendRequest('/services/updatesynchrostatus');
			if (OPENMISstatus < 300) 	{
				if (OPENMISresponse == '<ret>true</ret>') {
				//update message.		
					var mess = OpenMISgetElement('status');
					if(mess)	{
						mess.innerHTML = "Mise &agrave; jour de l'application termin&eacute;e. Veuillez relancer une nouvelle synchronisation pour r&eacute;cup&eacute;rer les tours.";
					}
					if (t) clearTimeout(t);
					return;
				}
			} else	{
					if (t) clearTimeout(t);
					return;
			} 
    } catch (err)	{}
	  t = setTimeout("makerequest()", 1000);
}

function testupdate()
{
	OpenMIScreateAJAX();
	makerequest();
}
	</script>
</if>

	 *
	 */

}
