/*
 * OpenMobileIS - a free Java(TM) Framework for mobile applications Java(TM)
 * Copyright (C) 2004-2009 Philippe Delrieu
 * All rights reserved.
 * Contact: pdelrieu@openmobileis.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *  Author : Philippe Delrieu
 * 
 */

package org.openmobileis.bundle.update.terminal;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Enumeration;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;

/**
 * @author pdelrieu
 *
 */
public final class UpdateJarOpenMisRestarter {

	/**
	 * 
	 */
	public UpdateJarOpenMisRestarter() {
	}
	
	public void updateApplication()	{
		try	{
			String path = System.getProperty("user.dir") + File.separator + "temp/"+ApplicationUpdateJarUtil.APPLICATION_JAR_FILENAME;
			File file = new File(path);
			if (file.exists()) {
			
		//send HTTP shutdown request.
	//	Send with socket no HTTP client use.
		//wait end shutdown
//		wait 3 second
		//update jar
				this.unzipInstallJar();
			}
		//start openmis.
		} catch (Throwable ex){
			
		}
	}

	private void unzipInstallJar() throws IOException {
		String basepath = System.getProperty("user.dir") + File.separator;
		String path = basepath + "temp/" + ApplicationUpdateJarUtil.APPLICATION_JAR_FILENAME;
		File file = new File(path);
		if (file.exists()) {
			JarFile jarFile = new JarFile(path);
			try {
				for (Enumeration e = jarFile.entries(); e.hasMoreElements();) {
					JarEntry jarEntry = (JarEntry) e.nextElement();
					String completeName = jarEntry.getName();
					// get file directory and test if exist.
					if (jarEntry.isDirectory()) {
						File dirToCreate = new File(basepath + completeName);
						if (!dirToCreate.exists()) {
							dirToCreate.mkdirs();
						}
						continue;
					}
					int index = completeName.lastIndexOf("/");
					if (index != -1) {
						File repToCreate = new File(basepath + completeName.substring(0, index));
						if (!repToCreate.exists()) {
							repToCreate.mkdirs();
						}
					}
					FileOutputStream stream = new FileOutputStream(basepath + completeName);
					BufferedOutputStream bos = null;
					InputStream in = jarFile.getInputStream(jarEntry);
					try {
						int read_bytes = 0;
						byte[] buffer = new byte[4096];
						bos = new BufferedOutputStream(stream, buffer.length);
						// LogManager.traceDebug(0, "DEBUG TIME in ApacheHTTPCientSynchroConduit dans unZipData() av while : "+new Date(System.currentTimeMillis()));
						while ((read_bytes = in.read(buffer, 0, buffer.length)) != -1) {
							bos.write(buffer, 0, read_bytes);
						}
						// LogManager.traceDebug(0, "DEBUG TIME in ApacheHTTPCientSynchroConduit dans unZipData() ap while : "+new Date(System.currentTimeMillis()));
					} finally {
						if (bos != null) {
							bos.flush();
							bos.close();
							stream.close();
						}
						in.close();
					}
				}
			} finally {
				if (jarFile != null) {
					try {
						jarFile.close();
					} catch (IOException ioe) {
					}
				}
			}
		}
	}
}
