/*
 * OpenMobileIS - a free Java(TM) Framework for mobile applications Java(TM)
 * Copyright (C) 2006-2008 Ubikis
 * All rights reserved.
 * Contact: pdelrieu@openmobileis.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *  Author : Philippe Delrieu
 *  
 *  Modifications :
 *  Creation P.Delrieu
 * 
 */
package org.openmobileis.module.test.server;

import org.openmobileis.common.user.UserNotFoundException;
import org.openmobileis.common.util.collection.Array;
import org.openmobileis.common.util.exception.ServiceException;
import org.openmobileis.common.util.log.LogManager;
import org.openmobileis.database.fastobjectdb.FastObjectDB;
import org.openmobileis.database.fastobjectdb.synchro.server.FODBSyncTarget;
import org.openmobileis.synchro.algo.replication.SynchroAtomicObject;
import org.openmobileis.synchro.algo.replication.SynchroConflicResolver;
import org.openmobileis.synchro.openmsp.OpenMSPException;
import org.openmobileis.synchro.security.auth.Credential;

/**
 * Title:        OpenMobileIS project source <BR>
 * Description: 
 * 
 * @author	Philippe Delrieu
 * @since	JDK 1.1
 * @version 1.0.
 */
public final class TestCollectionSynchroTargetV2 implements FODBSyncTarget {

	/**
	 * 
	 */
	public TestCollectionSynchroTargetV2() {
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.database.fastobjectdb.synchro.server.FODBSyncTarget#connect(org.openmobileis.synchro.security.auth.Credential)
	 */
	public void connect(Credential cred) throws UserNotFoundException, ServiceException {
		LogManager.traceInfo(0, "TestModuleSynchroTarget1 connect");
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.database.fastobjectdb.synchro.server.FODBSyncTarget#deleteCollectionObject(java.lang.String)
	 */
	public void deleteCollectionObject(String id, long updateSynchroNumber) throws OpenMSPException {
		LogManager.traceInfo(0, "TestModuleSynchroTarget1 deletecollection");
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.database.fastobjectdb.synchro.server.FODBSyncTarget#disconnect()
	 */
	public void disconnect() {
		LogManager.traceInfo(0, "TestModuleSynchroTarget1 disconnect");
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.database.fastobjectdb.synchro.server.FODBSyncTarget#getAllCollectionObject()
	 */
	public Array getAllCollectionObject() throws OpenMSPException {
		LogManager.traceInfo(0, "TestModuleSynchroTarget1 getAllCollectionObject");
		return null;
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.database.fastobjectdb.synchro.server.FODBSyncTarget#getAllModifiedAtomicObjectSince(long)
	 */
	public SynchroAtomicObject[] getAllModifiedAtomicObjectSince(long syncnumber) throws OpenMSPException {
		LogManager.traceInfo(0, "TestModuleSynchroTarget1 getAllModifiedAtomicObject");
		return null;
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.database.fastobjectdb.synchro.server.FODBSyncTarget#getCollectionName()
	 */
	public String getCollectionName() {
		return "testcollectionv2";
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.database.fastobjectdb.synchro.server.FODBSyncTarget#getCollectionObjectWithId(java.lang.String)
	 */
	public Object getCollectionObjectWithId(String id) throws OpenMSPException {
		LogManager.traceInfo(0, "TestModuleSynchroTarget1 getCollectionObjectWithId");
		return null;
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.database.fastobjectdb.synchro.server.FODBSyncTarget#getConflicResolver()
	 */
	public SynchroConflicResolver getConflicResolver() {
		LogManager.traceInfo(0, "TestModuleSynchroTarget1 getConflicResolver");
		return null;
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.database.fastobjectdb.synchro.server.FODBSyncTarget#getUpdateMaxNbRow()
	 */
	public int getUpdateMaxNbRow() {
		LogManager.traceInfo(0, "TestModuleSynchroTarget1 getUpdateMaxNbRow");
		return 0;
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.database.fastobjectdb.synchro.server.FODBSyncTarget#setSendSynchroMetaData(java.lang.Object)
	 */
	public void setSendSynchroMetaData(Object metadata) throws OpenMSPException {
		LogManager.traceInfo(0, "TestModuleSynchroTarget1 setSendSynchroMetaData");

	}

	/* (non-Javadoc)
	 * @see org.openmobileis.database.fastobjectdb.synchro.server.FODBSyncTarget#updateCollectionObject(java.lang.Object)
	 */
	public void updateCollectionObject(Object obj, long updateSynchroNumber) throws OpenMSPException {
		LogManager.traceInfo(0, "TestModuleSynchroTarget1 updateCollectionObject");

	}

	/* (non-Javadoc)
	 * @see org.openmobileis.database.fastobjectdb.synchro.server.FODBSyncTarget#updateSynchroDB(org.openmobileis.database.fastobjectdb.FastObjectDB)
	 */
	public void updateSynchroDB(FastObjectDB db) throws OpenMSPException {
		LogManager.traceInfo(0, "TestModuleSynchroTarget1 updateSynchroDB");

	}

}
