/*
 * OpenMobileIS - a free Java(TM) Framework for mobile applications Java(TM)
 * Copyright (C) 2004-2006 Philippe Delrieu
 * All rights reserved.
 * Contact: pdelrieu@openmobileis.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *  Author : Philippe Delrieu
 *
 */

package org.openmobileis.module.test.server;

import java.io.File;
import java.util.Properties;

import org.openmobileis.common.user.UserManager;
import org.openmobileis.common.user.profile.ProfileDataManager;
import org.openmobileis.common.user.profile.impl.XmlFileProfilDataFactory;
import org.openmobileis.common.util.PropertiesManager;
import org.openmobileis.common.util.exception.ServiceException;
import org.openmobileis.common.util.file.FileUtilities;
import org.openmobileis.common.util.log.FileLogManager;
import org.openmobileis.common.util.log.LogManager;
import org.openmobileis.services.servlet.OpenMISInit;
import org.openmobileis.synchro.algo.syncnumber.SyncNumberManager;
import org.openmobileis.synchro.algo.syncnumber.impl.EmptySyncNumberManagerDelegate;

public class TestSynchroOSGIOpenMISInit implements OpenMISInit {

  public TestSynchroOSGIOpenMISInit() {
    super();
  }

  public void preLoadingInit() throws ServiceException {
    //init database.
    try {
    	System.out.println("test acccent ééékdd");
    	
      Properties  props = new Properties();
      props.put("org.openmobileis.common.log.file", System.getProperty("user.dir")+"/WEB-INF/log/serverlog.txt");
      File file = new File(System.getProperty("user.dir")+"/WEB-INF/log");
      if (file.exists())   FileLogManager.registerLogManager(props); //log to a file
      else LogManager.registerLogManager(null); //log to a console

      PropertiesManager.getManager().addProperty("org.openmobileis.common.user.profil.xmlprofilfile.path",System.getProperty("user.dir") + "/WEB-INF/conf/defaultprofils.xml");
      // init user manager with the default impl with one user. Login:test Pwd:test
      //to authenticate to another source, use your UserManagerFactory
      UserManager.getManager().registerUserManagerFactoryForGroup("default", new TestBundleUserManagerFactory());
      //register the sync nyumber manager. Sync number identify a db modification in the time.
      //every modification on db data is tracked with a sync number.
      SyncNumberManager.getManager().registerDelegate(new EmptySyncNumberManagerDelegate());

      // init profil management with default profil. All synchronized collection must be in the profil.
      //edit the defaultprofils.xml file to add your collection.
      ProfileDataManager.getManager().registerProfilDataFactoryForGroup("default", new XmlFileProfilDataFactory());
    } catch (Throwable ex)  {
      throw new ServiceException(ex);
    }
 }

  public void postLoadingInit() throws ServiceException {

	    //Start OSGI Container	
	  System.setProperty("org.osgi.framework.dir", System.getProperty("user.dir")+"/osgifwk/repository");
	  System.setProperty("org.knopflerfish.verbosity", "9");
	  //remove old context 
	  String dir =  System.getProperty("user.dir")+"/osgifwk/repository";
	  FileUtilities.deleteDir(new File(dir));
	  
		org.knopflerfish.framework.Main.main(new String[0]);
  }

}
