package org.openmobileis.module.test.terminal;

import org.openmobileis.common.util.PropertiesManager;
import org.openmobileis.common.util.log.LogManager;
import org.openmobileis.module.terminal.ModuleManager;
import org.openmobileis.synchro.client.SynchroDescriptor;
import org.openmobileis.synchro.client.SynchroManager;
import org.openmobileis.synchro.openmsp.client.OpenMSPSynchroManager;
import org.openmobileis.synchro.openmsp.client.conduit.ApacheHTTPClientSynchroConduit;
import org.openmobileis.synchro.security.auth.Credential;

public final class TestSynchroTerminal {

	public TestSynchroTerminal() {
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		LogManager.registerLogManager(null);
		try	{
			
			PropertiesManager.getManager().addProperty("org.openmobileis.synchro.client.openmsp.numsyncpropsfile", System.getProperty("user.dir")+"/WEB-INF/conf/numsync.properties");
	    //init db propeties.
	    PropertiesManager.getManager().addProperty("fastobjectdb.database.path", System.getProperty("user.dir")+"/database");
	    PropertiesManager.getManager().addProperty("fastobjectdb.database.name", "db");
			
			SynchroDescriptor descriptor = new SynchroDescriptor();
	    descriptor.addProperty("OpenMSPsynchrotype", "DR"); // to say direct synchro not mandatory. Can be use if you have different type of synchronisation. To identify them on the server side.
	    String useragent = OpenMSPSynchroManager.getManager().getSynchroUserAgent(descriptor);
	    
	 //   OpenMSPSynchroManager.getManager().addListener(new TestOpenMSPSyncListener(), null);
	    
	  	ApacheHTTPClientSynchroConduit conduit = new ApacheHTTPClientSynchroConduit();
	  	conduit.setSynchroPath(System.getProperty("user.dir")+"/synchro");  //path where synchro file are stored
	  	conduit.setSynchroUserAgent(useragent); // synchro client user agent. Use to identify the terminal type on the server side
	  	descriptor.setSynchroConduit(conduit);
	  	descriptor.setSynchroGroup("default");
	  	descriptor.setServerURL("http://localhost:9091/services/openmspservice");
	  	
	    Credential cred = new Credential("test", "test");
	    SynchroManager.getManager().registerSynchroProcessor(OpenMSPSynchroManager.getManager());
	    
	    //init module management
	    ModuleManager.getManager().initModule();
	    
	    SynchroManager.getManager().doSynchro(cred, descriptor);
	    int status = OpenMSPSynchroManager.getManager().getGlobalSynchroStatut();
	    LogManager.traceInfo(0, "Synchro result :"+status);
		} catch (Throwable ex)	{
			LogManager.traceError(0, ex);
		}
	
	}

}
