/**
 * 
 */
package org.openmobileis.common.util.file;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import org.openmobileis.common.util.collection.Array;

/**
 * @author pdelrieu
 *
 */
public class OpenMisArchive {
	private Array entryList;
	/**
	 * 
	 */
	public OpenMisArchive() {
		entryList = new Array();
	}
	
	public void addEntry(OpenMisArchiveEntry entry)	{
		entryList.add(entry);
	}
	
	public void addEntry(String name, byte[] data)	{
		entryList.add(new OpenMisArchiveEntry(name, data));
	}
	
	public OpenMisArchiveEntry getEntry(int index){
		if (index < this.entryList.size()){
			return (OpenMisArchiveEntry)this.entryList.get(index);
		}
		return null;
	}
	
	public int getEntryCount()	{
		return entryList.size();
	}
	
	public byte[] encodeArchive() throws IOException	{
		ByteArrayOutputStream bout = new ByteArrayOutputStream();
		DataOutputStream dout = new DataOutputStream(bout);
		dout.writeInt(entryList.size());
		int size = this.entryList.size();
		for (int i=0; i<size; i++)	{
			OpenMisArchiveEntry entry = (OpenMisArchiveEntry)this.entryList.get(i);
			dout.writeUTF(entry.getName());
			dout.writeInt(entry.getData().length);
			dout.write(entry.getData());
		}
		dout.flush();
		dout.close();
		return bout.toByteArray();
	}
	
	public static OpenMisArchive decodeArchive(byte[] archive) throws IOException	{
		ByteArrayInputStream bin = new ByteArrayInputStream(archive);
		DataInputStream din = new DataInputStream(bin);
		OpenMisArchive newarchive = new OpenMisArchive();
		int nbEntry = din.readInt();
		for (int i=0; i<nbEntry; i++){
			String name = din.readUTF();
			int length = din.readInt();
			byte[] entry = new byte[length];
			din.read(entry, 0, length);
			newarchive.addEntry(name, entry);
		}
		return newarchive;
	}

}
