/*
 * OpenMobileIS - a free Java(TM) Framework for mobile applications Java(TM)
 * Copyright (C) 2004-2006 Philippe Delrieu
 * All rights reserved.
 * Contact: pdelrieu@openmobileis.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *  Author : Philippe Delrieu
 *  
 *  Modifications :
 *  Creation P.Delrieu
 * 
 */
package org.openmobileis.modules.common.gui;

import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Frame;

/**
 * 
 * @author phil
 *
 */
public final class PocketPCSynchroProgressBar {
  public static final Color WHITE = new Color(255,255,255);
	private Frame frame;
	private ProgressBar prgBar;
	/**
	 * 
	 */
	public PocketPCSynchroProgressBar(String frameName) {
   	frame = new Frame(frameName);
   	frame.setBackground(WHITE);
   	Dimension framedim =  java.awt.Toolkit.getDefaultToolkit().getScreenSize();
   	frame.setSize(framedim);		
		frame.setLayout(new BorderLayout());
		
   	Canvas canhaut = new Canvas();
   	canhaut.setBackground(WHITE);
   	canhaut.setSize(framedim.width, framedim.height/3);
    frame.add(BorderLayout.NORTH, canhaut);
   	Canvas canbas = new Canvas();
   	canbas.setBackground(WHITE);
   	canbas.setSize(framedim.width, framedim.height/3);
    frame.add(BorderLayout.SOUTH,canbas);
   	Canvas caneast = new Canvas();
   	caneast.setSize(framedim.width/8, framedim.height/2);
   	caneast.setBackground(WHITE);
    frame.add(BorderLayout.EAST,caneast);
   	Canvas canwest = new Canvas();
   	canwest.setSize(framedim.width/8, framedim.height/2);
   	canwest.setBackground(WHITE);
    frame.add(BorderLayout.WEST,canwest);
   	prgBar = new ProgressBar();
   //	prgBar.setPreferredSize(hautdim);
   	frame.add( prgBar); 
	}
	
	public PocketPCSynchroProgressBar() {
   	this("Synchronisation");
	}
	
	public void setVisible()	{
		frame.setVisible(true);
		frame.toFront();
	}
	
	public void dispose()	{
		frame.setVisible(false);
		frame.dispose();
	}
	
	/**
	 * show the specified percentage of the progress bar
	 * @param percent : from 0 to 100 percent of the progress bar to show
	 */
	public void setProgressBar(int percent)	{
		prgBar.updateBar(percent);
	}

}
