/*
 * OpenMobileIS - a free Java(TM) Framework for mobile applications Java(TM)
 * Copyright (C) 2004-2006 Philippe Delrieu
 * All rights reserved.
 * Contact: pdelrieu@openmobileis.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *  Author : Philippe Delrieu
 *
 *  Modifications :
 *  2004 Creation P.Delrieu
 *
 */
package org.openmobileis.services;

import javax.servlet.http.HttpServletRequest;

import org.openmobileis.common.util.exception.ServiceException;

import freemarker.template.TemplateModelRoot;

/**
 * Title:        OpenMobileIS project source <BR>
 * Description: Base classe to develop an edit service
 * @author  Philippe Delrieu
 * @since JDK 1.1
 * @version 1.0.
 */
public interface StepEditService {


	public void fillTemplateWithSessionData(Object sessionDatas, HttpServletRequest req, TemplateModelRoot templateData) throws ServiceException;
	public void fillSessionObjectWithRequestData(Object sessionDatas, HttpServletRequest req) throws ServiceException;
	public String getTemplateName(Object sessionDatas, HttpServletRequest req);

	/**
	 * return true if the session data are  for the step, false otherwise.
	 * @param sessionDatas
	 * @param req
	 * @param templateData
	 * @throws ServiceException
	 */
	public boolean validateSessionStepData(Object sessionDatas, HttpServletRequest req, TemplateModelRoot templateData) throws ServiceException;

	/**
	 * return the last step name. Null if no last step.
	 * @return
	 */
	public String getLastStepName(Object sessionDatas, HttpServletRequest req);

	/**
	 * return the next step name. Null if no next step.
	 * @return
	 */
	public String getNextStepName(Object sessionDatas, HttpServletRequest req);

	/**
	 * return the step name. Step name are append to the MultiStepMainservice URI to call a step.
	 * @return
	 */
	public String getStepName();

}
