/*
 * OpenMobileIS - a free Java(TM) Framework for mobile applications Java(TM)
 * Copyright (C) 2004-2006 Philippe Delrieu
 * All rights reserved.
 * Contact: pdelrieu@openmobileis.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *  Author : Philippe Delrieu
 *  
 *  Modifications :
 *  Creation P.Delrieu
 * 
 */
package org.openmobileis.synchro.openmsp.client.conduit;

import org.openmobileis.modules.common.gui.PocketPCSynchroProgressBar;
import org.openmobileis.synchro.openmsp.client.OpenMSPSynchroProcessListener;

/**
 * @author phil
 *
 */
public final class PPCProgressBarSynchroProcessListener implements OpenMSPSynchroProcessListener {
	private PocketPCSynchroProgressBar progressBar;
	/**
	 * 
	 */
	public PPCProgressBarSynchroProcessListener() {
		// TODO Auto-generated constructor stub
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.synchro.openmsp.client.OpenMSPSynchroProcessListener#notifyAfterProcessMessageReturn()
	 */
	public void notifyAfterProcessMessageReturn() {
		progressBar.setProgressBar(80);
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.synchro.openmsp.client.OpenMSPSynchroProcessListener#notifyBeforeProcessMessageReturn()
	 */
	public void notifyBeforeProcessMessageReturn() {
		progressBar.setProgressBar(60);

	}

	/* (non-Javadoc)
	 * @see org.openmobileis.synchro.openmsp.client.OpenMSPSynchroProcessListener#notifyBeforeSendMessage()
	 */
	public void notifyBeforeSendMessage() {
		progressBar.setProgressBar(20);

	}

	/* (non-Javadoc)
	 * @see org.openmobileis.synchro.openmsp.client.OpenMSPSynchroProcessListener#notifyGenerateOpenMSPMessage()
	 */
	public void notifyGenerateOpenMSPMessage() {
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.synchro.openmsp.client.OpenMSPSynchroProcessListener#notifyListenerEndSync(java.lang.String)
	 */
	public void notifyListenerEndSync(String listenerName) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see org.openmobileis.synchro.openmsp.client.OpenMSPSynchroProcessListener#notifyListenerStartSync(java.lang.String)
	 */
	public void notifyListenerStartSync(String listenerName) {

	}

	/* (non-Javadoc)
	 * @see org.openmobileis.synchro.openmsp.client.OpenMSPSynchroProcessListener#notifyReceiveMessageReturn()
	 */
	public void notifyReceiveMessageReturn() {
		progressBar.setProgressBar(50);

	}

	/* (non-Javadoc)
	 * @see org.openmobileis.synchro.openmsp.client.OpenMSPSynchroProcessListener#notifySynchroEnd()
	 */
	public void notifyEndProcessListener() {
		progressBar.setProgressBar(80);
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.synchro.openmsp.client.OpenMSPSynchroProcessListener#notifySynchroEnd()
	 */
	public void notifySynchroEnd() {
		progressBar.setProgressBar(100);
		progressBar.dispose();
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.synchro.openmsp.client.OpenMSPSynchroProcessListener#notifySynchroFailure(int)
	 */
	public void notifySynchroFailure(int status) {

	}

	/* (non-Javadoc)
	 * @see org.openmobileis.synchro.openmsp.client.OpenMSPSynchroProcessListener#notifySynchroStart()
	 */
	public void notifySynchroStart() {
		if (progressBar != null) progressBar.dispose();
		progressBar = new PocketPCSynchroProgressBar();
		progressBar.setProgressBar(10);
		progressBar.setVisible();
	}

}
