/*
 * OpenMobileIS - a free Java(TM) Framework for mobile applications Java(TM)
 * Copyright (C) 2004-2009 Philippe Delrieu
 * All rights reserved.
 * Contact: pdelrieu@openmobileis.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *  Author : Philippe Delrieu
 * 
 */

package org.openmobileis.synchro.openmsp.server.util;

import java.io.IOException;
import java.util.HashMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.openmobileis.common.context.UserTerminal;
import org.openmobileis.common.user.profile.Profile;
import org.openmobileis.common.util.exception.SynchroException;
import org.openmobileis.common.util.file.OpenMisArchive;

/**
 * @author pdelrieu
 *
 */
public final class CLDCSynchroFileGenerator implements SynchroFileGenerator {

	/**
	 * 
	 */
	public CLDCSynchroFileGenerator() {
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.synchro.openmsp.server.util.SynchroFileGenerator#generateSynchroFile(org.openmobileis.common.context.UserTerminal, org.openmobileis.common.user.profile.Profile, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse, org.openmobileis.synchro.openmsp.server.util.FileSystem, java.lang.String)
	 */
	public void generateSynchroFile(UserTerminal terminal, Profile profil, HttpServletRequest request, HttpServletResponse res, FileSystem fileSystem, String newSessionId) throws SynchroException {
		try {
			//manage added zipEntryMemoryFiles
			HashMap zipFileMap = new HashMap(10);
			OpenMISFile[] syncfileList = fileSystem.getFileList();
			OpenMisArchive ret = new OpenMisArchive();
			for (int i = 0; i < syncfileList.length; i++) {
				ret.addEntry(syncfileList[i].getFileName(), syncfileList[i].getFileData());
			}
      res.addHeader("SyncNum", newSessionId);
      res.setContentType("application/zip");
  /*    byte[] retArray = array.toByteArray();
      res.setContentLength(retArray.length);
      res.getOutputStream().write(retArray);  */
	} catch (IOException ex) {
			throw new SynchroException("Error during synchro file genration ", ex);
		}

	}

}
