/*
 * OpenMobileIS - a free Java(TM) Framework for mobile applications Java(TM)
 * Copyright (C) 2004-2009 Philippe Delrieu
 * All rights reserved.
 * Contact: pdelrieu@openmobileis.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *  Author : Philippe Delrieu
 * 
 */

package org.openmobileis.test.mock.synchro;

import org.openmobileis.common.user.UserNotFoundException;
import org.openmobileis.common.util.exception.SynchroException;
import org.openmobileis.synchro.openmsp.client.conduit.ConduitParameter;
import org.openmobileis.synchro.openmsp.client.conduit.SynchroConduit;

/**
 * @author pdelrieu
 *
 */
public final class MockSynchroConduit implements SynchroConduit {
	private String synchroPath;
	/**
	 * 
	 */
	public MockSynchroConduit(String synchroPath) {
		this.synchroPath = synchroPath;
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.synchro.openmsp.client.conduit.SynchroConduit#closeRAS()
	 */
	public void closeRAS() throws SynchroException {
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.synchro.openmsp.client.conduit.SynchroConduit#getIntallPath()
	 */
	public String getIntallPath() {
		return this.synchroPath;
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.synchro.openmsp.client.conduit.SynchroConduit#getRASConnectionNames()
	 */
	public String getRASConnectionNames() {
		return "";
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.synchro.openmsp.client.conduit.SynchroConduit#isConnected()
	 */
	public boolean isConnected() {
		return true;
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.synchro.openmsp.client.conduit.SynchroConduit#openRAS()
	 */
	public void openRAS() throws SynchroException {
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.synchro.openmsp.client.conduit.SynchroConduit#sendRequest(org.openmobileis.synchro.openmsp.client.conduit.ConduitParameter[], java.lang.String, java.lang.String)
	 */
	public String sendRequest(ConduitParameter[] parameters, String request, String url) throws SynchroException, UserNotFoundException {
		return "";
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.synchro.openmsp.client.conduit.SynchroConduit#setSynchroPath(java.lang.String)
	 */
	public void setSynchroPath(String path) {
		this.synchroPath = path;
	}

	/* (non-Javadoc)
	 * @see org.openmobileis.synchro.openmsp.client.conduit.SynchroConduit#setSynchroUserAgent(java.lang.String)
	 */
	public void setSynchroUserAgent(String userAgent) {
	}

}
